DECLARE SUB GameWalkSouth ()
DECLARE SUB GameWalkNorth ()
DECLARE SUB GameWalkWest ()
DECLARE SUB GameWalkEast ()
DECLARE SUB StatAboutMenu ()
DECLARE SUB StatOptionsMenu ()
DECLARE SUB StatEndGame ()
DECLARE FUNCTION StatCursorKey% ()
DECLARE SUB StatOpenMenu ()
DECLARE SUB StatOpenBox (Page%, X%, Y%, X2%, Y2%)
DECLARE SUB DoPlayTriggerSound ()
DECLARE SUB XFXQuake (Times%)
DECLARE SUB DoAutoTriggers ()
DECLARE SUB DoMapTriggers ()
DECLARE FUNCTION GameTriggerOn% (Z%)
DECLARE SUB GameSetTrigger (Z%, Num%)
DECLARE SUB DoTriggerEffects ()
DECLARE SUB GameIntro ()
DECLARE SUB MLoopMIDI ()
DECLARE SUB MIntX (IntNum AS INTEGER, Regs AS ANY)
DECLARE SUB MDetectSettings (BasePort%, IRQ%, LoDMA%, HiDMA%, CardType%, MPU401%)
DECLARE SUB DoLoadMap (Map$)
DECLARE SUB GameNPCTalk (Num%)
DECLARE FUNCTION GameDetectNPC% ()
DECLARE SUB DoDrawNPCs ()
DECLARE SUB TextCloseBox ()
DECLARE SUB TextClearBox ()
DECLARE SUB TextShowText ()
DECLARE SUB TextOpenBox ()
DECLARE SUB TextSetFont ()
DECLARE SUB TextResetLines ()
DECLARE FUNCTION GameNoDamWalk% (Xoff%, Yoff%)
DECLARE FUNCTION GameLoadFont% (FontName$)
DECLARE SUB DoDetectOnScript ()
DECLARE FUNCTION GameDetectEnemy% (X%, Y%)
DECLARE FUNCTION GameEnemyWalk% (Num%, Xoff%, Yoff%)
DECLARE SUB GameImageIndex (ImageArray%(), IndexArray%())
DECLARE SUB DoDrawStatus ()
DECLARE SUB DoMapLimitsBounce ()
DECLARE FUNCTION GameWalk% (Xoff%, Yoff%)
DECLARE SUB GameEnemyMovement (N%)
DECLARE SUB DoAttackEnemy ()
DECLARE SUB DoCheckForBasicExits ()
DECLARE SUB DoMovePlayer ()
DECLARE SUB DoControls ()
DECLARE SUB GameStart ()
DECLARE SUB DoDrawSprites ()
DECLARE SUB GameInitialise ()
DECLARE SUB DoMapScript ()
DECLARE SUB DoVIDEOShow ()
DECLARE SUB DoDrawScenery ()
DECLARE SUB DoDrawUnderLayer (Animate%)
DECLARE SUB GameLoadImages (FileName$, ImageArray%())
DECLARE SUB GameInitEMS ()
DECLARE SUB MStopMIDI ()
DECLARE SUB MLoadMidi (FileName$)
DECLARE SUB MPlayMidi ()
DECLARE SUB DoMidi (FileName$)
DECLARE SUB GameLoadPalette ()
DECLARE FUNCTION MIDIError$ ()
DECLARE FUNCTION MBytesRequired& (FileName$)
DECLARE SUB MInternalGetIntVector (IntNum%, Segment%, Offset%)
DECLARE FUNCTION MTimeMIDI! ()
'$INCLUDE: 'directqb.bi'
'$DYNAMIC
'Set these all to "" when a demo is ready
CONST YES = 1
CONST NO = 0
CONST NOMOVE = -1
CONST ATTACKING = 99
'''''''''''''
TYPE Registers
         AX    AS INTEGER
         BX    AS INTEGER
         CX    AS INTEGER
         dx    AS INTEGER
         BP    AS INTEGER
         SI    AS INTEGER
         DI    AS INTEGER
         FLAGS AS INTEGER
         DS    AS INTEGER
         ES    AS INTEGER
END TYPE
IntXCodeData:
DATA  &H55, &H8B, &HEC, &H83, &HEC, &H08, &H56, &H57, &H1E, &H55, &H8B, &H5E
DATA  &H06, &H8B, &H47, &H10, &H3D, &HFF, &HFF, &H75, &H04, &H1E, &H8F, &H47
DATA  &H10, &H8B, &H47, &H12, &H3D, &HFF, &HFF, &H75, &H04, &H1E, &H8F, &H47
DATA  &H12, &H8B, &H47, &H08, &H89, &H46, &HF8, &H8B, &H07, &H8B, &H4F, &H04
DATA  &H8B, &H57, &H06, &H8B, &H77, &H0A, &H8B, &H7F, &H0C, &HFF, &H77, &H12
DATA  &H07, &HFF, &H77, &H02, &H1E, &H8F, &H46, &HFA, &HFF, &H77, &H10, &H1F
DATA  &H8B, &H6E, &HF8, &H5B, &HCD, &H21, &H55, &H8B, &HEC, &H8B, &H6E, &H02
DATA  &H89, &H5E, &HFC, &H8B, &H5E, &H06, &H1E, &H8F, &H46, &HFE, &HFF, &H76
DATA  &HFA, &H1F, &H89, &H07, &H8B, &H46, &HFC, &H89, &H47, &H02, &H89, &H4F
DATA  &H04, &H89, &H57, &H06, &H58, &H89, &H47, &H08, &H89, &H77, &H0A, &H89
DATA  &H7F, &H0C, &H9C, &H8F, &H47, &H0E, &H06, &H8F, &H47, &H12, &H8B, &H46
DATA  &HFE, &H89, &H47, &H10, &H5A, &H1F, &H5F, &H5E, &H8B, &HE5, &H5D, &HCA
DATA  &H02, &H00
DIM SHARED QMIDIRegs AS Registers, MEM.SEGMENT AS INTEGER
DIM SHARED MIDI.PLAYTIME AS SINGLE, MIDI.ERROR AS INTEGER, PAUSED AS SINGLE
DIM SHARED SBMIDI.INTERRUPT AS INTEGER, MEM.ALLOCATED AS LONG
DIM SHARED SBSIM.INTERRUPT AS INTEGER, MIXER.CHIP AS INTEGER
DIM SHARED SB.BASEPORT AS INTEGER, SB.IRQ AS INTEGER
DIM SHARED SB.LODMA AS INTEGER, SB.HIDMA AS INTEGER, SB.CARDTYPE AS INTEGER
DIM SHARED SB.MPU401 AS INTEGER, BIT.STORAGE(0 TO 7) AS INTEGER
DIM SHARED SENSITIVE AS INTEGER, REVERSE.STEREO AS INTEGER
DIM SHARED SOUND.DISABLED AS INTEGER
IF SBMIDI.INTERRUPT = 0 THEN SBMIDI.INTERRUPT = &H80
IF SBSIM.INTERRUPT = 0 THEN SBSIM.INTERRUPT = &H81
MDetectSettings SB.BASEPORT, SB.IRQ, SB.LODMA, SB.HIDMA, SB.CARDTYPE, SB.MPU401
IF SB.BASEPORT = 0 THEN SB.BASEPORT = &H220
IF SB.IRQ = 0 THEN SB.IRQ = 5
IF SB.LODMA = 0 THEN SB.LODMA = 1
IF SB.HIDMA = 0 AND SB.CARDTYPE = 6 THEN SB.HIDMA = 5
''''''''''''
DIM SHARED MidiToggle, Map$, Script$, TileSetNo, AnimFrames, TimeToAnim
DIM SHARED UnderMoveX, UnderMoveY, MIDISET, Scr$, MaxWalkScripts, ControlLoop
DIM SHARED ControlFrame, East$, West$, North$, South$, AttackDone, MaxEnemys
DIM SHARED EnemyXoff, EnemyYoff, FlashLoop, EnemyNumber, FontLoaded
DIM SHARED TextBoxOpen, TextPoint, TextSpeed, MaxNPCs, DoWaterOnLoad
DIM SHARED BlockedMap$, WaterScrollTally, OldMidi$, Trigger$
DIM SHARED CursorPosition
''''''''''''
DIM SHARED Chidir$, PixDir$, MidDir$, MovieDir$
Chidir$ = ""
PixDir$ = ""
MidDir$ = ""
MovieDir$ = ""
''''''''''''
TYPE PlayerType
X AS INTEGER
Y AS INTEGER
MoveDir AS INTEGER
Turn AS INTEGER
Power AS INTEGER
Armor AS INTEGER
Weapon AS INTEGER
Suit AS INTEGER
HP AS INTEGER
MaxHP AS INTEGER
Frame AS INTEGER
END TYPE

TYPE NPCType
X AS INTEGER
Y AS INTEGER
TalkNumber AS INTEGER
Turn AS INTEGER
TileSetNo AS INTEGER
END TYPE

TYPE ItemType
Cost AS INTEGER
Effect AS INTEGER
Target AS INTEGER
ObjName AS STRING * 15
DefType AS INTEGER
END TYPE

TYPE EnemyType
X AS INTEGER
Y AS INTEGER
HP AS INTEGER
Power AS INTEGER
Armor AS INTEGER
MoveDir AS INTEGER
Frame AS INTEGER
Turn AS INTEGER
Dead AS INTEGER
Decay AS INTEGER
WalkDelay AS INTEGER
WalkLoop AS INTEGER
TileSetNo AS INTEGER
DeathX AS INTEGER
DeathY AS INTEGER
Flying AS INTEGER
END TYPE

TYPE WalkScript
OX AS INTEGER
OY AS INTEGER
NX AS INTEGER
NY AS INTEGER
ScrFile AS STRING * 12
END TYPE

TYPE TextChopType
X AS INTEGER
Y AS INTEGER
C AS INTEGER
END TYPE

''''''''''''
DIM SHARED Player AS PlayerType
''''''''''''
TextSpeed = 1
OPEN Chidir$ + "options.dat" FOR INPUT AS #1
INPUT #1, ControlLoop
INPUT #1, MidiToggle
CLOSE #1
AnimFrames = 2
MIDISET = NO
DoWaterOnLoad = YES
''''''''''''
REDIM SHARED Map%(15, 8), TileData%(1 TO 1), TileIndex%(1 TO 1)
REDIM SHARED OnStepScript(0) AS WalkScript, Edata%(1 TO 1), EIndex%(1 TO 1)
REDIM SHARED PlayerData%(1 TO 1), PlayerIndex%(1 TO 1), Enemies(0) AS EnemyType
REDIM SHARED DefTile(120), TextString$(9), TextChop(4) AS TextChopType
REDIM SHARED NPCs(20) AS NPCType, Triggers(400), Cursor%(1 TO 1)
''''''''''''
DIM SHARED Pal AS STRING * 768, Font AS STRING * 2305
CLS : SCREEN 13
GameInitialise
MStopMIDI

DoLoadMap "start"
DoMapScript
DQBgetpal Pal
DQBpaloff
DoVIDEOShow
DQBfadein Pal
DQBclearlayer 3
'
GameStart         '
'

DQBremoveKeyboard
DQBclose
MStopMIDI

REM $STATIC
SUB DoAttackEnemy

IF Player.Turn = 0 THEN Picture = 1
IF Player.Turn = 1 THEN Picture = 6
IF Player.Turn = 2 THEN Picture = 11
IF Player.Turn = 3 THEN Picture = 16

Addr = 0

DO
FOR Z = 0 TO 2
DQBclearlayer 2
DoDrawSprites
DQBPut 2, Player.X * 20, Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture + Addr))), VARPTR(PlayerData%(PlayerIndex%(Picture + Addr)))
DoDrawUnderLayer YES
DoVIDEOShow
NEXT
IF Addr = 0 THEN Addr = 3: GOTO LoopAttack
IF Addr = 3 THEN Addr = 4: GOTO LoopAttack
IF Addr = 4 THEN EXIT DO
LoopAttack:
LOOP

Turn = Player.Turn
XO = 0: YO = 0
IF Turn = 0 THEN YO = 1
IF Turn = 1 THEN YO = -1
IF Turn = 2 THEN XO = 1
IF Turn = 3 THEN XO = -1
X = Player.X + XO
Y = Player.Y + YO
EnemyNumber = 0
IF GameDetectEnemy(X, Y) = 1 THEN
Damage = Player.Power - Enemy.Armor
IF Damage < 0 THEN Damage = 1
Enemies(EnemyNumber).HP = Enemies(EnemyNumber).HP - Damage
IF Enemies(EnemyNumber).HP <= 0 THEN
Enemies(EnemyNumber).Dead = YES
E = EnemyNumber
Enemies(E).DeathX = 0: Enemies(E).DeathY = 0
M = Enemies(E).MoveDir
IF M = 0 THEN Enemies(E).DeathY = Enemies(E).Frame
IF M = 1 THEN Enemies(E).DeathY = -Enemies(E).Frame
IF M = 2 THEN Enemies(E).DeathX = Enemies(E).Frame
IF M = 3 THEN Enemies(E).DeathX = -Enemies(E).Frame
RANDOMIZE TIMER
Enemies(EnemyNumber).Decay = INT(RND * 170) + 340
E = 0
END IF
END IF


Addr = 4

DO
FOR Z = 0 TO 2
DQBclearlayer 2
DoDrawSprites
DQBPut 2, Player.X * 20, Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture + Addr))), VARPTR(PlayerData%(PlayerIndex%(Picture + Addr)))
DoDrawUnderLayer YES
DoVIDEOShow
NEXT
IF Addr = 3 THEN Addr = 0: GOTO LoopAttack2
IF Addr = 4 THEN Addr = 3: GOTO LoopAttack2
IF Addr = 0 THEN EXIT DO
LoopAttack2:
LOOP


END SUB

SUB DoAutoTriggers

M$ = LCASE$(Map$)
IF M$ = "chidungx" THEN
IF Enemies(1).Dead = YES AND Enemies(1).Decay < 1 THEN
DQBgetpal Pal
DQBfadeto 63, 63, 63
MStopMIDI
DoLoadMap "e2"
DoMapScript
Player.X = 4
Player.Y = 5
DoVIDEOShow
Player.MaxHP = Player.MaxHP + 10
Player.HP = Player.MaxHP
Player.Power = Player.Power + 1
DQBfadein Pal
Triggers(2) = YES
TextSetFont
TextResetLines
TextOpenBox
TextString$(1) = "Well done Gyuhn. You have proved"
TextString$(2) = "yourself a stronger warrior then"
TextString$(3) = "we assumed."
TextString$(4) = "xx"
TextShowText
CLS
PRINT "That is the end of the demo."
PRINT "I planned it to be bigger, but"
PRINT "I released it prematurely."
DQBwaitkey KEYSPACE
DQBfadeto 0, 0, 0
DQBremoveKeyboard
DQBclose
END
EXIT SUB
END IF
END IF

IF M$ = "chidung3" AND Player.X = 7 AND Player.Y = 3 AND Triggers(1) = NO THEN
XFXQuake 30
DoPlayTriggerSound
Triggers(1) = YES
END IF

END SUB

SUB DoCheckForBasicExits

BlockedMap$ = Map$
IF Player.X = 16 THEN
IF East$ = "none" THEN Player.X = 15: EXIT SUB
DoLoadMap East$
Player.X = 0
IF GameNoDamWalk(0, 0) = NO THEN
Player.X = 15
DoLoadMap BlockedMap$
DoMapScript
FOR Z = 1 TO WaterScrollTally
DQBscroll 5, UnderMoveX, UnderMoveY
NEXT Z
EXIT SUB
END IF
WaterScrollTally = 0
DoMapScript
EXIT SUB
END IF
IF Player.X = -1 THEN
IF West$ = "none" THEN Player.X = 0: EXIT SUB
DoLoadMap West$
Player.X = 15
IF GameNoDamWalk(0, 0) = NO THEN
Player.X = 0
DoLoadMap BlockedMap$
DoMapScript
FOR Z = 1 TO WaterScrollTally
DQBscroll 5, UnderMoveX, UnderMoveY
NEXT Z
EXIT SUB
END IF
WaterScrollTally = 0
DoMapScript
EXIT SUB
END IF
IF Player.Y = -1 THEN
IF North$ = "none" THEN Player.Y = 0: EXIT SUB
DoLoadMap North$
Player.Y = 9
IF GameNoDamWalk(0, 0) = NO THEN
Player.Y = 0
DoLoadMap BlockedMap$
DoMapScript
FOR Z = 0 TO WaterScrollTally
DQBscroll 1, UnderMoveX, UnderMoveY
NEXT Z
EXIT SUB
END IF
WaterScrollTally = 0
DoMapScript
EXIT SUB
END IF
IF Player.Y = 9 THEN
IF South$ = "none" THEN Player.Y = 8: EXIT SUB
DoLoadMap South$
Player.Y = 0
IF GameNoDamWalk(0, 0) = NO THEN
Player.Y = 8
DoLoadMap BlockedMap$
DoMapScript
FOR Z = 1 TO WaterScrollTally
DQBscroll 5, UnderMoveX, UnderMoveY
NEXT Z
EXIT SUB
END IF
WaterScrollTally = 0
DoMapScript
EXIT SUB
END IF

END SUB

SUB DoControls

'CONST SOUTH = 0, NORTH = 1: EAST = 2: WEST = 3
IF DQBkey(29) THEN
IF AttackDone > 0 THEN AttackDone = AttackDone - 1: EXIT SUB
Player.MoveDir = ATTACKING
DoAttackEnemy
Player.MoveDir = NOMOVE
AttackDone = 2
EXIT SUB
END IF

AttackDone = 0

IF DQBkey(KEYESC) THEN
StatOpenMenu
EXIT SUB
END IF

IF DQBkey(KEYRIGHT) THEN
GameWalkEast
EXIT SUB
END IF

IF DQBkey(KEYLEFT) THEN
GameWalkWest
EXIT SUB
END IF

IF DQBkey(KEYUP) THEN
GameWalkNorth
EXIT SUB
END IF

IF DQBkey(KEYDOWN) THEN
GameWalkSouth
EXIT SUB
END IF

IF DQBkey(KEYSPACE) THEN
TextResetLines
TextSetFont
TextNumber = GameDetectNPC
LOCATE 2, 1
PRINT Map$
IF TextNumber > 0 THEN
GameNPCTalk TextNumber
END IF
END IF

END SUB

SUB DoDetectOnScript

IF MaxWalkScripts = 0 THEN EXIT SUB
FOR Z = 1 TO MaxWalkScripts
IF Player.X = OnStepScript(Z).OX AND Player.Y = OnStepScript(Z).OY THEN
DQBgetpal Pal
DQBfadeto 0, 0, 0
Player.X = OnStepScript(Z).NX
Player.Y = OnStepScript(Z).NY
DoLoadMap LTRIM$(RTRIM$(OnStepScript(Z).ScrFile))
DoMapScript
DQBclearlayer 2
DoDrawSprites
DoDrawUnderLayer YES
DoVIDEOShow
DQBfadein Pal
EXIT SUB
END IF

NEXT Z

END SUB

SUB DoDrawNPCs

IF MaxNPCs = 0 THEN EXIT SUB
FOR Z = 1 TO MaxNPCs
Picture = (NPCs(Z).TileSetNo * 9) + 1
Pict = (NPCs(Z).Turn * 2) + INT(RND * 2)
X = NPCs(Z).X
Y = NPCs(Z).Y
Picture = Picture + Pict

DQBPut 2, (X * 20), (Y * 20), VARSEG(Edata%(EIndex%(Picture))), VARPTR(Edata%(EIndex%(Picture)))

NEXT

END SUB

SUB DoDrawScenery

FOR X = 0 TO 15
FOR Y = 0 TO 8
TileToDraw = Map%(X, Y)
IF TileToDraw < 1 THEN TileToDraw = 1
DQBPut 4, X * 20, Y * 20, VARSEG(TileData%(TileIndex%(TileToDraw))), VARPTR(TileData%(TileIndex%(TileToDraw)))
NEXT
NEXT

END SUB

SUB DoDrawSprites


'''''''

IF MaxEnemys = 0 THEN GOTO ContinueOn

'X AS INTEGER
'Y AS INTEGER
'HP AS INTEGER
'Power AS INTEGER
'Armor AS INTEGER
'MoveDir AS INTEGER
'Frame AS INTEGER
'Turn AS INTEGER
'Dead AS INTEGER
'Decay AS INTEGER
'WalkDelay AS INTEGER
'WalkLoop AS INTEGER
'TileSetNo AS INTEGER
FOR D = 1 TO MaxEnemys
IF Enemies(D).Dead = NO THEN GOTO Yomba
IF Enemies(D).Decay > 0 THEN
EnemyXoff = Enemies(D).DeathX
EnemyYoff = Enemies(D).DeathY
X = Enemies(D).X
Y = Enemies(D).Y
RANDOMIZE TIMER
Picture = (Enemies(D).TileSetNo * 9) + 1
Picture = Picture + 8
DQBPut 2, (X * 20) + EnemyXoff, (Y * 20) + EnemyYoff, VARSEG(Edata%(EIndex%(Picture))), VARPTR(Edata%(EIndex%(Picture)))
END IF
Yomba:
NEXT D

FOR XX = 0 TO 15
FOR YY = 0 TO 8
FOR Z = 1 TO MaxEnemys

X = Enemies(Z).X
Y = Enemies(Z).Y

IF XX = X AND YY = Y THEN
RANDOMIZE TIMER
Picture = (Enemies(Z).TileSetNo * 9) + 1

EnemyXoff = 0: EnemyYoff = 0

GameEnemyMovement Z

Pict = (Enemies(Z).Turn * 2) + INT(RND * 2)

IF Enemies(Z).Dead = YES THEN Pict = 8

Picture = Picture + Pict

IF Enemies(Z).Dead = YES THEN GOTO Tomba

DQBPut 2, (X * 20) + EnemyXoff, (Y * 20) + EnemyYoff, VARSEG(Edata%(EIndex%(Picture))), VARPTR(Edata%(EIndex%(Picture)))
END IF

Tomba:

IF Player.MoveDir = NOMOVE AND XX = Player.X AND YY = Player.Y THEN
IF Player.Turn = 0 THEN Picture = 1
IF Player.Turn = 1 THEN Picture = 6
IF Player.Turn = 2 THEN Picture = 11
IF Player.Turn = 3 THEN Picture = 16
DQBPut 2, Player.X * 20, Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
END IF

NEXT Z
NEXT
NEXT
EXIT SUB
ContinueOn:
DoDrawNPCs
IF Player.MoveDir = NOMOVE THEN
IF Player.Turn = 0 THEN Picture = 1
IF Player.Turn = 1 THEN Picture = 6
IF Player.Turn = 2 THEN Picture = 11
IF Player.Turn = 3 THEN Picture = 16
DQBPut 2, Player.X * 20, Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
END IF


END SUB

SUB DoDrawStatus

DQBboxf 1, 0, 180, 319, 199, 16
DQBbox 1, 2, 182, 317, 197, 1
DQBPset 1, 2, 182, 16
DQBPset 1, 2, 197, 16
DQBPset 1, 317, 182, 16
DQBPset 1, 317, 197, 16
DQBPrint 1, LTRIM$(STR$(Player.HP)) + "/" + LTRIM$(STR$(Player.MaxHP)) + CHR$(3), 5, 185, 4

END SUB

SUB DoDrawUnderLayer (Animate)

IF Animate = YES THEN
TimeToAnim = TimeToAnim + 1
IF AnimFrames = 0 THEN GOTO AnimateTiles
IF TimeToAnim = AnimFrames THEN
AnimateTiles:
DQBscroll 5, UnderMoveX, UnderMoveY
TimeToAnim = 0
END IF
EXIT SUB
END IF

IF Animate = NO THEN
TimeToAnim = 0
TileToDraw = 1
DQBclearlayer 5
IF TileSetNo = 1 THEN TileToDraw = 2
IF TileSetNo = 2 THEN TileToDraw = 2
IF TileSetNo = 3 THEN TileToDraw = 2
FOR X = 0 TO 15
FOR Y = 0 TO 9
DQBPut 5, X * 20, Y * 20, VARSEG(TileData%(TileIndex%(TileToDraw))), VARPTR(TileData%(TileIndex%(TileToDraw)))
NEXT
NEXT
EXIT SUB
END IF


END SUB

REM $DYNAMIC
SUB DoLoadMap (Map$)
FOR Z = 1 TO 10
IF DoWaterOnLoad = NO THEN
IF Z <> 5 THEN DQBclearlayer Z
ELSE
DQBclearlayer Z
END IF
NEXT
REDIM OnStepScript(0) AS WalkScript
REDIM Enemies(0) AS EnemyType

MaxNPCs = 0
AnimFrames = 20
MaxEnemys = 0
MaxWalkScripts = 0
Scr$ = Map$
UnderMoveX = 1
UnderMoveY = 0
MaxWalkScripts = 0
Script$ = Map$
CLOSE
OPEN Chidir$ + Map$ + ".map" FOR INPUT AS #1
East$ = "none"
West$ = "none"
North$ = "none"
South$ = "none"
L = TileSetNo
REDIM DefTile(120)
INPUT #1, TileSetNo
REDIM TileData%(1 TO 1)
REDIM TileIndex%(1 TO 1)
GameLoadImages PixDir$ + "chi" + LTRIM$(STR$(TileSetNo)) + ".put", TileData%()
GameImageIndex TileData%(), TileIndex%()
OPEN Chidir$ + "chi" + LTRIM$(STR$(TileSetNo)) + ".blk" FOR INPUT AS #5
FOR Z = 1 TO 120
INPUT #5, DefTile(Z)
NEXT Z
CLOSE #5
FOR X = 0 TO 15
FOR Y = 0 TO 8
INPUT #1, Map%(X, Y)
NEXT
NEXT
IF DoWaterOnLoad = YES THEN DoDrawUnderLayer NO    'L5 Moving Water Layer
Trigger$ = Scr$
DoDrawScenery          'L4 SceneryLayer
DQBclearlayer 3        'L3 GoreLayer
DQBclearlayer 2        'L2 SpriteLayer
DQBclearlayer 1        'L1 MainLayer
REDIM TileData%(1 TO 1)
REDIM TileIndex%(1 TO 1)
CLOSE
EXIT SUB

' Layer Specific Functions
'
' 1 - Every Page is copied here...
' 2 - The sprite layer....(Enemies and You, etc)
' 3 - ...
' 4 - The background (Scenery)
' 5 - The underlayer (Moving Water... ETC)
' 6+ Unknown



END SUB

REM $STATIC
SUB DoMapLimitsBounce

IF Player.X > 15 THEN Player.X = 15
IF Player.X < 0 THEN Player.X = 0
IF Player.Y < 0 THEN Player.Y = 0
IF Player.Y > 8 THEN Player.Y = 8

END SUB

SUB DoMapScript

MIDISET = NO
OPEN Chidir$ + Scr$ + ".scp" FOR BINARY AS #25
IF LOF(25) = 0 THEN CLOSE #25: KILL Chidir$ + Scr$ + ".scp": EXIT SUB
CLOSE
OPEN Chidir$ + Scr$ + ".scp" FOR INPUT AS #25
WHILE NOT EOF(25)
INPUT #25, Script$
Script$ = LCASE$(Script$)
IF Script$ = "" THEN GOTO NewLineOfScript
IF Script$ = ";" THEN GOTO NewLineOfScript
IF Script$ = "watermovexy" THEN
INPUT #25, UnderMoveX, UnderMoveY
END IF
IF Script$ = "setanimframes" THEN
INPUT #25, AnimFrames
END IF
IF Script$ = "end script" THEN
GOTO EndOfScript
END IF
IF Script$ = "setmidi" THEN
INPUT #25, MIDI$
IF LCASE$(MIDI$) <> LCASE$(OldMidi$) THEN DoMidi MIDI$: OldMidi$ = MIDI$
MIDISET = YES
END IF
IF Script$ = "set onstep" THEN
INPUT #25, MaxWalkScripts
REDIM OnStepScript(MaxWalkScripts) AS WalkScript
FOR Z = 1 TO MaxWalkScripts
INPUT #25, X, Y, X2, Y2, ScrFile$
OnStepScript(Z).OX = X
OnStepScript(Z).OY = Y
OnStepScript(Z).ScrFile = ScrFile$
OnStepScript(Z).NX = X2
OnStepScript(Z).NY = Y2
NEXT Z
GOTO NewLineOfScript
END IF
IF Script$ = "set basic exits" THEN
INPUT #25, South$
INPUT #25, North$
INPUT #25, East$
INPUT #25, West$
GOTO NewLineOfScript
END IF
IF Script$ = "set monster" THEN
INPUT #25, MaxEnemys
REDIM Enemies(MaxEnemys) AS EnemyType
FOR ENPC = 1 TO MaxEnemys
INPUT #25, X, Y, HP, PW, AR, W, T
Enemies(ENPC).X = X
Enemies(ENPC).Y = Y
Enemies(ENPC).HP = HP
Enemies(ENPC).Power = PW
Enemies(ENPC).Armor = AR
Enemies(ENPC).WalkDelay = W
Enemies(ENPC).TileSetNo = T
Enemies(ENPC).Frame = 0
Enemies(ENPC).MoveDir = NOMOVE
Enemies(ENPC).Turn = 0
Enemies(ENPC).Dead = NO
Enemies(ENPC).WalkLoop = 0
NEXT ENPC
GOTO NewLineOfScript
END IF
IF Script$ = "set npc" THEN
INPUT #25, MaxNPCs
FOR Z = 1 TO MaxNPCs
INPUT #25, X, Y, TNum, Turn, Tset
NPCs(Z).X = X
NPCs(Z).Y = Y
NPCs(Z).Turn = Turn
NPCs(Z).TileSetNo = Tset
NPCs(Z).TalkNumber = TNum
NEXT Z
GOTO NewLineOfScript
END IF

NewLineOfScript:
WEND
EndOfScript:
CLOSE #25

DoTriggerEffects
DoMapTriggers

END SUB

SUB DoMapTriggers
IF Trigger$ = "chidung2" AND Triggers(1) = NO OR Triggers(2) = YES AND Trigger$ = "chidung2" THEN
Map%(3, 3) = 1
END IF
IF Trigger$ = "outhos" AND Triggers(2) = YES THEN
MaxNPCs = 0
END IF

END SUB

REM $DYNAMIC
SUB DoMidi (FileName$)

OldMidi$ = FileName$
IF MidiToggle = NO THEN EXIT SUB
IF MIDISET = YES THEN EXIT SUB
MStopMIDI
MLoadMidi MidDir$ + FileName$
MPlayMidi

END SUB

REM $STATIC
SUB DoMovePlayer

IF Player.Frame = 20 THEN EXIT SUB

Player.Frame = Player.Frame + 1

RANDOMIZE TIMER
Addr = INT(RND * 2) + 1

DoActionPlayer:
IF Player.Turn = 0 THEN
Picture = 1 + Addr
DQBPut 2, Player.X * 20, Player.Y * 20 - (20 - Player.Frame), VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
EXIT SUB
END IF
IF Player.Turn = 1 THEN
Picture = 6 + Addr
DQBPut 2, Player.X * 20, Player.Y * 20 + (20 - Player.Frame), VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
EXIT SUB
END IF
IF Player.Turn = 2 THEN
Picture = 11 + Addr
DQBPut 2, Player.X * 20 - (20 - Player.Frame), Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
EXIT SUB
END IF
IF Player.Turn = 3 THEN
Picture = 16 + Addr
DQBPut 2, Player.X * 20 + (20 - Player.Frame), Player.Y * 20, VARSEG(PlayerData%(PlayerIndex%(Picture))), VARPTR(PlayerData%(PlayerIndex%(Picture)))
EXIT SUB
END IF



END SUB

SUB DoPlayTriggerSound

IF MidiToggle = NO THEN EXIT SUB
MIDISET = NO
A$ = OldMidi$
DoMidi "trigger.mid"
A% = VAL(RIGHT$(TIME$, 2))
IF A% > 56 THEN A% = 60 - A%
DO
X% = VAL(RIGHT$(TIME$, 2))
LOOP UNTIL X% = A% + 4
MIDISET = NO
DoMidi A$

END SUB

SUB DoTriggerEffects
IF Trigger$ = "chidung2" AND Triggers(1) = NO THEN


END IF
END SUB

SUB DoVIDEOShow

DQBcopylayer 5, 1
DQBcopytranslayer 4, 1
DQBclearlayer 3
DQBcopytranslayer 2, 1
DoDrawStatus

DQBcopylayer 1, VIDEO
MLoopMIDI
END SUB

FUNCTION GameDetectEnemy (X, Y)
GameDetectEnemy = 0
IF MaxEnemys = 0 THEN EXIT FUNCTION
FOR Z = 1 TO MaxEnemys
IF Enemies(Z).X = X AND Enemies(Z).Y = Y AND Enemies(Z).Dead = NO THEN
GameDetectEnemy = 1
EnemyNumber = Z
EXIT FUNCTION
END IF
NEXT Z


END FUNCTION

FUNCTION GameDetectNPC

Xoff = 0: Yoff = 0: GameDetectNPC = 0
IF Player.Turn = 0 THEN Yoff = 1
IF Player.Turn = 1 THEN Yoff = -1
IF Player.Turn = 2 THEN Xoff = 1
IF Player.Turn = 3 THEN Xoff = -1

X = Player.X + Xoff
Y = Player.Y + Yoff
IF MaxNPCs = 0 THEN GameDetectNPC = 0: EXIT FUNCTION
FOR Z = 1 TO MaxNPCs
GameDetectNPC = 0
IF NPCs(Z).X = X AND NPCs(Z).Y = Y THEN GameDetectNPC = NPCs(Z).TalkNumber: EXIT FUNCTION
NEXT Z
GameDetectNPC = 0

END FUNCTION

SUB GameEnemyMovement (N)

IF MaxEnemys = 0 THEN EXIT SUB
IF N > MaxEnemys THEN EXIT SUB

EnemyXoff = 0: EnemyYoff = 0
IF Enemies(N).Dead = YES THEN
Enemies(N).MoveDir = NOMOVE
Enemies(N).Decay = Enemies(N).Decay - 1
IF Enemies(N).Decay < -1 THEN Enemies(N).Decay = -1
EXIT SUB
END IF
ReChoose:
IF Enemies(N).MoveDir = NOMOVE THEN
IF Enemies(N).WalkLoop < Enemies(N).WalkDelay THEN Enemies(N).WalkLoop = Enemies(N).WalkLoop + 1: EXIT SUB
Enemies(N).MoveDir = INT(RND * 4)
Move = Enemies(N).MoveDir
Enemies(N).Turn = Enemies(N).MoveDir
XO = 0: YO = 0
IF Move = 0 THEN YO = 1
IF Move = 1 THEN YO = -1
IF Move = 2 THEN XO = 1
IF Move = 3 THEN XO = -1
'''''''''''''''''''''''''''
IF GameEnemyWalk(N, XO, YO) = 0 THEN Enemies(N).MoveDir = NOMOVE: GOTO ReChoose
Enemies(N).WalkLoop = 0
Enemies(N).Frame = 0
EnemyXoff = 0: EnemyYoff = 0
END IF

IF Enemies(N).MoveDir <> NOMOVE THEN
EnemyXoff = 0: EnemyYoff = 0
Enemies(N).Frame = Enemies(N).Frame + 1
Frame = Enemies(N).Frame
Move = Enemies(N).MoveDir
IF Move = 0 THEN EnemyYoff = Frame
IF Move = 1 THEN EnemyYoff = -Frame
IF Move = 2 THEN EnemyXoff = Frame
IF Move = 3 THEN EnemyXoff = -Frame
X = Enemies(N).X: Y = Enemies(N).Y
IF Move = 0 AND Y = 8 THEN Enemies(N).MoveDir = NOMOVE: GOTO ReChoose
IF Move = 1 AND Y = 0 THEN Enemies(N).MoveDir = NOMOVE: GOTO ReChoose
IF Move = 2 AND X = 15 THEN Enemies(N).MoveDir = NOMOVE: GOTO ReChoose
IF Move = 3 AND X = 0 THEN Enemies(N).MoveDir = NOMOVE: GOTO ReChoose
END IF

IF Enemies(N).Frame = 10 THEN
Move = Enemies(N).MoveDir
Y = Enemies(N).Y
X = Enemies(N).X
Damaged = NO
IF Player.Y = Y AND Player.X = X AND Move = 0 AND GameNoDamWalk(0, 1) = YES THEN Player.Y = Player.Y + 1: Damaged = YES
IF Player.Y = Y AND Player.X = X AND Move = 1 AND GameNoDamWalk(0, -1) = YES THEN Player.Y = Player.Y - 1: Damaged = YES
IF Player.X = X AND Player.Y = Y AND Move = 2 AND GameNoDamWalk(1, 0) = YES THEN Player.X = Player.X + 1: Damaged = YES
IF Player.X = X AND Player.Y = Y AND Move = 3 AND GameNoDamWalk(-1, 0) = YES THEN Player.X = Player.X - 1: Damaged = YES
IF Damaged = YES THEN
Damage = Enemies(N).Power - Player.Armor
IF Damage < 1 THEN Damage = 1
Player.HP = Player.HP - Damage
FlashLoop = 40
END IF
END IF

IF Enemies(N).Frame = 20 THEN
Move = Enemies(N).MoveDir
IF Move = 0 THEN Enemies(N).Y = Enemies(N).Y + 1
IF Move = 1 THEN Enemies(N).Y = Enemies(N).Y - 1
IF Move = 2 THEN Enemies(N).X = Enemies(N).X + 1
IF Move = 3 THEN Enemies(N).X = Enemies(N).X - 1
Enemies(N).MoveDir = NOMOVE
Enemies(N).Frame = 0
Y = Enemies(N).Y
X = Enemies(N).X
Damaged = NO
IF Player.Y = Y AND Player.X = X AND Move = 0 AND GameNoDamWalk(0, 1) = YES THEN Player.Y = Player.Y + 1: Damaged = YES
IF Player.Y = Y AND Player.X = X AND Move = 1 AND GameNoDamWalk(0, -1) = YES THEN Player.Y = Player.Y - 1: Damaged = YES
IF Player.X = X AND Player.Y = Y AND Move = 2 AND GameNoDamWalk(1, 0) = YES THEN Player.X = Player.X + 1: Damaged = YES
IF Player.X = X AND Player.Y = Y AND Move = 3 AND GameNoDamWalk(-1, 0) = YES THEN Player.X = Player.X - 1: Damaged = YES
IF Damaged = YES THEN
Damage = Enemies(N).Power - Player.Armor
IF Damage < 1 THEN Damage = 1
Player.HP = Player.HP - Damage
FlashLoop = 40
END IF
END IF

EXIT SUB

END SUB

FUNCTION GameEnemyWalk (Num, Xoff, Yoff)

GameEnemyWalk = 0
X = Enemies(Num).X + Xoff
Y = Enemies(Num).Y + Yoff
IF X < 0 OR X > 15 THEN EXIT FUNCTION
IF Y < 0 OR Y > 8 THEN EXIT FUNCTION
IF MaxNPCs = 0 THEN GOTO RedSix
FOR Z = 1 TO MaxNPCs
IF X = NPCs(Z).X AND Y = NPCs(Z).Y THEN EXIT FUNCTION
NEXT Z

RedSix:
GameEnemyWalk = DefTile(Map%(X, Y))



END FUNCTION

REM $DYNAMIC
SUB GameImageIndex (ImageArray%(), IndexArray%())
'* MakeImageIndex() subroutine:
'* Constructs an image position index for the images held in an image array.
'*
'* Parameters:
'* ImageArray() - Dynamic, integer array holding images to be indexed.
'* IndexArray() - Dynamic, integer array to hold the index for images in
'*                ImageArray().
'*

    'The index will initially be built in a temporary array, allowing
    'for the maximum 1000 images per file.
    DIM TEMP%(1 TO 120)
    Ptr& = 1: IndexNo = 1: LastInt = UBOUND(ImageArray%)
    DO
        TEMP%(IndexNo) = Ptr&
        IndexNo = IndexNo + 1

        'Evaluate descriptor of currently referenced image to
        'calculate the beginning of the next image.
        X& = (ImageArray%(Ptr&) \ 8) * (ImageArray%(Ptr& + 1)) + 4
        IF X& MOD 2 THEN X& = X& + 1
        Ptr& = Ptr& + (X& \ 2)
    LOOP WHILE Ptr& < LastInt

    LastImage = IndexNo - 1

    'Copy the image index values into the actual index array.
    REDIM IndexArray%(1 TO LastImage)
    FOR N = 1 TO LastImage
        IndexArray%(N) = TEMP%(N)
    NEXT N

END SUB

SUB GameInitEMS

A = DQBinit(10, 0)
IF A <> 0 THEN
CLS : SCREEN 0: WIDTH 80
PRINT "An error occured while loading DirectQB."
PRINT "Error #" + LTRIM$(STR$(A))
PRINT ""
IF A = 1 THEN COLOR 4 ELSE COLOR 15
PRINT " 1. 386 or better CPU not detected."
IF A = 2 THEN COLOR 4 ELSE COLOR 15
PRINT " 2. Unable to find an expanded memory manager."
IF A = 3 THEN COLOR 4 ELSE COLOR 15
PRINT " 3. Not enough free EMS."
COLOR 15
DQBclose
END
END IF


END SUB

REM $STATIC
SUB GameInitialise

GameInitEMS

GameIntro
DQBclearlayer VIDEO

GameLoadPalette

GameLoadImages PixDir$ + "man1.put", PlayerData%()
GameImageIndex PlayerData%(), PlayerIndex%()
GameLoadImages PixDir$ + "enemy.put", Edata%()
GameImageIndex Edata%(), EIndex%()
GameLoadImages PixDir$ + "chicurs.put", Cursor%()
FontLoaded = GameLoadFont(Chidir$ + "wotc.fnt")

DQBinstallKeyboard

Player.X = 5
Player.Y = 6
Player.Turn = 2
Player.Frame = 0
Player.Power = 3
Player.Armor = 0
Player.HP = 40
Player.MaxHP = 40
Player.MoveDir = NOMOVE
FlashLoop = 10
MaxWalkScripts = 0
MStopMIDI
END SUB

SUB GameIntro
CLS
SCREEN 13

IF MidiToggle = YES THEN
MLoadMidi MidDir$ + "title.mid"
MPlayMidi
END IF

DQBwait 300
A = DQBloadLayer(1, MovieDir$ + "vid11.pcx", Pal)
DQBsetPal Pal
DQBpaloff
DQBcopylayer 1, VIDEO
DQBfadein Pal
DQBwait 150
FOR Z = 2 TO 15
A = DQBloadLayer(1, MovieDir$ + "vid1" + LTRIM$(RTRIM$(STR$(Z))) + ".pcx", Pal)
DQBsetPal Pal
DQBcopylayer 1, VIDEO
NEXT Z

DQBwait 100
DQBfadeto 63, 63, 63

DQBclearlayer VIDEO
A$ = "Press a key to begin..."
DQBsettextstyle BOLD
DQBPrint VIDEO, A$, 160 - ((LEN(A$) * 8) / 2), 96, 4
DQBfadein Pal

WHILE INKEY$ = "": WEND
DQBfadeto 0, 0, 0
MStopMIDI
DQBsettextstyle NONE

END SUB

FUNCTION GameLoadFont (FontName$)

GameLoadFont = NO
OPEN FontName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN CLOSE : EXIT FUNCTION
GET #255, , Font
CLOSE
GameLoadFont = YES

END FUNCTION

REM $DYNAMIC
'* InitImageData() subroutine:
'* Initializes an integer array with image data - this must be done before
'* displaying an image using the PUT(graphics) statement. The calling value
'* of FileName$ dictates whether the data should be read directly from an
'* image file or from DATA statements (see below).
'*
'* Parameters:
'*    FileName$ - The name of the image file to load. This must include the
'*                path to the file if it does not reside in the current
'*                directory. If FileName$ is an empty string (""), image
'*                data is read from DATA statements.
'* ImageArray() - Dynamic, integer array to hold the image data.
'*
'* Note: Before calling InitImageData() to initialize images from DATA
'*       statements, use an appropriate RESTORE statement to ensure the
'*       correct DATA statements are read.
'*
SUB GameLoadImages (FileName$, ImageArray%())

    IF FileName$ <> "" THEN
        '***** Read image data from file *****

        'Establish size of integer array required.
        FileNo = FREEFILE
        OPEN FileName$ FOR BINARY AS #FileNo
        Ints = (LOF(FileNo) - 7) \ 2
        CLOSE #FileNo
        REDIM ImageArray%(1 TO Ints)

        'Load image data directly into array memory.
        DEF SEG = VARSEG(ImageArray%(1))
        BLOAD FileName$, 0
        DEF SEG
    ELSE
        '***** Read image data from DATA statements *****

        'Establish size of integer array required.
        READ IntCount
        REDIM ImageArray(1 TO IntCount)

        'READ image DATA into array.
        FOR N = 1 TO IntCount
            READ X
            ImageArray(N) = X
        NEXT N
    END IF

END SUB

REM $STATIC
SUB GameLoadPalette

FF = FREEFILE
OPEN Chidir$ + "chichi.pal" FOR BINARY AS #FF
GET #FF, , Pal
CLOSE #FF
DQBsetPal Pal

END SUB

FUNCTION GameNoDamWalk (Xoff, Yoff)

X = Player.X + Xoff
Y = Player.Y + Yoff
GameNoDamWalk = YES
IF X > 15 THEN EXIT FUNCTION
IF X < 0 THEN EXIT FUNCTION
IF Y < 0 THEN EXIT FUNCTION
IF Y > 8 THEN EXIT FUNCTION
IF MaxNPCs = 0 THEN GOTO DoZag
FOR Z = 1 TO MaxNPCs
IF X = NPCs(Z).X AND Y = NPCs(Z).Y THEN EXIT FUNCTION
NEXT Z
DoZag:
WalkTest = Map%(X, Y)
L = DefTile(WalkTest)
IF L = 0 THEN GameNoDamWalk = NO: EXIT FUNCTION

END FUNCTION

SUB GameNPCTalk (Num)

M$ = LCASE$(Map$)
TextResetLines
TextSetFont
''''''''''''''''''
'Map  Stars
IF M$ = "stars" AND Num = 1 THEN
TextOpenBox
TextResetLines
TextSetFont
TextString$(1) = "Sorry Gyuhn. You cannot leave until"
TextString$(2) = "Lord Zevan says so. We are planning"
TextString$(3) = "are a war against Malako. We can't"
TextString$(4) = "have anyone spying for them."
TextString$(5) = "xx"
TextShowText
EXIT SUB
END IF

'Map  E2
IF M$ = "e2" AND Num = 1 THEN
TextOpenBox
IF Triggers(0) = YES THEN
IF Player.X = 4 AND Player.Y = 3 THEN A$ = "exit" ELSE A$ = "enter at will"
TextString$(1) = "Gyuhn, you may " + A$ + "."
TextString$(2) = "xx"
IF NPCs(Num).X = 4 THEN
IF Player.X = 3 THEN NPCs(Num).X = 5 ELSE NPCs(Num).X = 3
END IF
TextShowText
EXIT SUB
ELSE
TextString$(1) = "Gyuhn, I suggest you ask"
TextString$(2) = "Lord Zevan for his permission"
TextString$(3) = "before entering the training"
TextString$(4) = "dungeon. I think he may be"
TextString$(5) = "in the outhouse."
TextString$(6) = "xx"
TextShowText
EXIT SUB
END IF
END IF
'''''''''''''''''''''
'Map  Outhos
IF M$ = "outhos" AND Num = 1 THEN
TextOpenBox
IF Triggers(0) = YES THEN
TextString$(1) = "Lord Zevan:"
TextString$(2) = "Gyuhn, go and enter the dungeon."
TextString$(3) = "One day you may go and defend"
TextString$(4) = "Chiton from attack."
TextString$(5) = "xx"
TextShowText
EXIT SUB
ELSE
TextString$(1) = "Lord Zevan:"
TextString$(2) = "Yes?"
TextString$(3) = "--"
TextString$(4) = "You want to enter the dungeon?"
TextString$(5) = "--"
TextString$(6) = "Well, I guess you need some skill"
TextString$(7) = "because soon we will conquer"
TextString$(8) = "Malako, in the south!"
TextString$(9) = "xx"
TextShowText
Triggers(0) = YES
EXIT SUB
END IF
END IF



END SUB

SUB GameResetTriggers

FOR Z = 0 TO 400
Triggers(Z) = NO   'Dungeon 1 Open Trigger
NEXT Z
END SUB

SUB GameStart

ControlFrame = 0

DO

IF FlashLoop < -1 THEN FlashLoop = -1
FlashLoop = FlashLoop - 1

DoCheckForBasicExits

DoDetectOnScript

DoMapLimitsBounce

DQBclearlayer 2

DoDrawSprites    'Controls Enemy&NPC Movement

DoDrawUnderLayer YES
WaterScrollTally = WaterScrollTally + 1
IF WaterScrollTally = 20 THEN WaterScrollTally = 0

DoVIDEOShow

DoAutoTriggers

'Edit this out when demo comes
LOCATE 1, 1: PRINT STR$(Player.X) + "/" + STR$(Player.Y)
LOCATE 2, 1: PRINT Map$
LOCATE 3, 1: PRINT TIME$
Map$ = Scr$

ControlFrame = ControlFrame + 1

EnemyNumber = 0

IF ControlFrame = ControlLoop THEN DoControls: ControlFrame = 0


LOOP
END SUB

FUNCTION GameWalk (Xoff, Yoff)

X = Player.X + Xoff
Y = Player.Y + Yoff
GameWalk = YES
IF X = 16 THEN EXIT FUNCTION
IF X = -1 THEN EXIT FUNCTION
IF Y = -1 THEN EXIT FUNCTION
IF Y = 9 THEN EXIT FUNCTION

IF MaxEnemys = 0 THEN GOTO Check4Bloks
FOR Z = 1 TO MaxEnemys
IF Enemies(Z).X = X AND Enemies(Z).Y = Y AND Enemies(Z).Dead = NO AND FlashLoop <= 0 THEN
GameWalk = NO
Damage = Enemies(Z).Power - Player.Armor
IF Damage < 0 THEN Damage = 1
Player.HP = Player.HP - Damage
FlashLoop = 30
EXIT FUNCTION
END IF
NEXT Z
Check4Bloks:
IF MaxNPCs = 0 THEN GOTO DoNag
FOR Z = 1 TO MaxNPCs
IF X = NPCs(Z).X AND Y = NPCs(Z).Y THEN GameWalk = NO: EXIT FUNCTION
NEXT Z
DoNag:
WalkTest = Map%(X, Y)
L = DefTile(WalkTest)
IF L = 0 THEN GameWalk = NO: EXIT FUNCTION


END FUNCTION

SUB GameWalkEast

IF Player.Turn <> 2 THEN Player.Turn = 2: EXIT SUB
IF East$ = "none" AND Player.X = 15 THEN Player.Turn = 2: EXIT SUB
IF GameWalk(1, 0) = NO THEN EXIT SUB
Player.X = Player.X + 1
Player.Frame = 0
Player.MoveDir = 2
FOR Z = 0 TO 19
DQBclearlayer 2
DoDrawSprites
DoMovePlayer
DoDrawUnderLayer YES
DoVIDEOShow
NEXT Z
Player.MoveDir = NOMOVE
END SUB

SUB GameWalkNorth
IF Player.Turn <> 1 THEN Player.Turn = 1: EXIT SUB
IF North$ = "none" AND Player.Y = 0 THEN Player.Turn = 1: EXIT SUB
IF GameWalk(0, -1) = NO THEN EXIT SUB
Player.Frame = 0
Player.MoveDir = 1
Player.Y = Player.Y - 1
FOR Z = 0 TO 19
DQBclearlayer 2
DoDrawSprites
DoMovePlayer
DoDrawUnderLayer YES
DoVIDEOShow
NEXT Z
Player.MoveDir = NOMOVE
END SUB

SUB GameWalkSouth
IF Player.Turn <> 0 THEN Player.Turn = 0: EXIT SUB
IF South$ = "none" AND Player.Y = 8 THEN Player.Turn = 0: EXIT SUB
IF GameWalk(0, 1) = NO THEN EXIT SUB
Player.Frame = 0
Player.MoveDir = 0
Player.Y = Player.Y + 1
FOR Z = 0 TO 19
DQBclearlayer 2
DoDrawSprites
DoMovePlayer
DoDrawUnderLayer YES
DoVIDEOShow
NEXT Z
Player.MoveDir = NOMOVE

END SUB

SUB GameWalkWest
IF Player.Turn <> 3 THEN Player.Turn = 3: EXIT SUB
IF West$ = "none" AND Player.X = 0 THEN Player.Turn = 3: EXIT SUB
IF GameWalk(-1, 0) = NO THEN EXIT SUB
Player.Frame = 0
Player.MoveDir = 3
Player.X = Player.X - 1
FOR Z = 0 TO 19
DQBclearlayer 2
DoDrawSprites
DoMovePlayer
DoDrawUnderLayer YES
DoVIDEOShow
NEXT Z
Player.MoveDir = NOMOVE
END SUB

'BytesRequired - Returns the amount of memory needed to store a file.
FUNCTION MBytesRequired& (FileName$)
'Open the file.
FF% = FREEFILE
OPEN FileName$ FOR BINARY AS #FF%
'Store the length of the file.
FileLen& = LOF(FF%)
'Close the file.
CLOSE FF%
'If the length of the file is 0, assume it does not exist and delete it.
IF FileLen& = 0 THEN
    KILL FileName$
    MIDI.ERROR = 1
    EXIT FUNCTION
END IF
'Return the length of the file as the number of bytes required.
MBytesRequired& = FileLen&
MIDI.ERROR = 0
END FUNCTION

SUB MDetectSettings (BasePort%, IRQ%, LoDMA%, HiDMA%, CardType%, MPU401%)

'Reset all of the variables
BasePort% = 0
IRQ% = 0
LoDMA% = 0
HiDMA% = 0
CardType% = 0
MPU401% = 0

'Read the BLASTER environment variable
Settings$ = ENVIRON$("BLASTER")

'Attempt to extract the base port, High DMA, Low DMA, IRQ, and card type
'from the BLASTER enironment variable.
FOR I% = 1 TO LEN(Settings$) - 1
        'If the type of sound card was found, get it and exit the loop.
        SELECT CASE UCASE$(MID$(Settings$, I%, 1))
                'If the card type was found...
                CASE "T"
                        CardType% = VAL(MID$(Settings$, I% + 1, 1))
                        'If the base port address was found...
                CASE "A"
                        BasePort% = VAL("&H" + LTRIM$(STR$(VAL(MID$(Settings$, I% + 1, 3)))))
                'If the IRQ was found...
                CASE "I"
                        IRQ% = VAL(MID$(Settings$, I% + 1, 2))
                'If the low DMA channel was found...
                CASE "D"
                        LoDMA% = VAL(MID$(Settings$, I% + 1, 1))
                'If the high DMA channel was found...
                CASE "H"
                        HiDMA% = VAL(MID$(Settings$, I% + 1, 1))
                'If the MPU401 port was found...
                CASE "P"
                        MPU401% = VAL("&H" + LTRIM$(STR$(VAL(MID$(Settings$, I% + 1, 3)))))
        END SELECT
NEXT I%

'If the card type wasn't found in the BLASTER variable, try to figure
'out the type using another method.

IF CardType% = 0 THEN
        'Examine the card's DMA channel.
        SELECT CASE LoDMA%
                'If the DMA is 210h or 230h, the card is an SB1.0/1.5.
                CASE &H210, &H230
                        CardType% = 1
                'If the DMA is 250h or 260h, the card is either an SB2CD or a
                'Sound Blaster 16.  It could also be a Sound Blaster 1.0/1.5,
                'but it probably isn't.  Actually, it's also unlikely that the card
                'is an SB16, but I check for it anyway, because there's an easy way
                'to tell if it is - the High DMA channel will be greater than
                '0.
                '
                'On the other hand, there's no way that I know of to
                'distinguish an SB 1.0 from an SB 2.0, except by looking at the
                'BLASTER environment variable.  And since this code is executing
                'that method obviously failed.
                CASE &H250, &H260
                        'Examining the High DMA channel will narrow it down.
                        'If the High DMA is greater than 0, the card is an SB16.
                        IF HiDMA% THEN
                                CardType% = 6
                        'Otherwise, define the card as a Sound Blaster 2.0.
                        ELSE
                                CardType% = 3
                        END IF
                'If the DMA channel is any other value....
                CASE ELSE
                        'Check the High DMA channel.  If it's a non-zero value,
                        'we've got an SB16.
                        IF HiDMA% THEN
                                CardType% = 6
                        'Otherwise....
                        ELSE
                                'If sensitive error checking is on, define the card as
                                'a Sound Blaster 1.0/1.5.
                                IF SENSITIVE THEN
                                        CardType% = 1
                                'Otherwise, assume it's a Sound Blaster Pro.
                                ELSE
                                        CardType% = 4
                                END IF
                        END IF
        END SELECT
END IF

'Determine the sound card's mixer chip
SELECT CASE CardType%
        'If the card could not be detected....
        CASE 0
                MIDI.ERROR = 7
                'If sensitive error checking is on, disable mixer operations
                IF SENSITIVE THEN
                        MIXER.CHIP = 0
                'Otherwise, assume the default mixer chip.
                ELSE
                        MIXER.CHIP = 2
                END IF
        'If the card is a Sound Blaster 1.0/1.5 or equivalent....
        CASE 1
                'Return an error.
                MIDI.ERROR = 6
                'If sensitive error checking is on, disable mixer operations and
                'exit.
                IF SENSITIVE THEN
                        MIXER.CHIP = 0
                        EXIT SUB
                'Otherwise, set the earliest mixer chip and continue.
                ELSE
                        MIXER.CHIP = 1
                END IF
        'If the card is a Sound Blaster 2.0/2.5 or equivalent....
        CASE 3
                'There are two different kinds of SB 2.0 cards: the regular SB2,
                'and the SB2CD.  The SB2CD has a mixer chip (the CT1335), whereas
                'the SB 2.0 does not.  The way to tell them apart is that the
                'Sound Blaster 2.0 uses Base Ports 220h and 240h, and the SB2CD
                'uses ports 250h and 260h.
                '
                'Assume the sound card is an SB2CD for now...
                MIXER.CHIP = 1
                'If the card is defined as an SB 2.0, not an SB 2.0 CD, and
                'sensitive error checking is on, disable mixer operations.
                IF (BasePort% = &H220 OR BasePort% = &H240) AND SENSITIVE <> 0 THEN
                        MIXER.CHIP = 0
                END IF
                MIDI.ERROR = 0
        'If the card is a Sound Blaster Pro, assume chip CT1345
        CASE 2, 4, 5
                MIXER.CHIP = 2
                MIDI.ERROR = 0
        'If the card is a Sound Blaster 16 or later, assume chip CT1745
        CASE IS >= 6
                MIXER.CHIP = 3
                MIDI.ERROR = 0
END SELECT

END SUB

'DriversLoaded - Attempt to detect if sound drivers are loaded
SUB MDriversLoaded (SBMIDI%, SBSIM%) STATIC
'Open the data file.
FF% = FREEFILE
OPEN "DRIVERS.DAT" FOR BINARY AS #FF%
'If the file is empty, return an error
FileSize& = LOF(FF%)
IF FileSize& = 0 THEN
    CLOSE FF%
    KILL "DRIVERS.DAT"
    MIDI.ERROR = 1
    EXIT SUB
'If the file is not exactly 1 kilobyte in size, return an error
ELSEIF FileSize& <> 1024 THEN
    CLOSE FF%
    MIDI.ERROR = 9
    EXIT SUB
END IF
'Load the driver data.
REDIM DRIVERDATA$(1 TO 5)
FOR I% = 1 TO 4
    DRIVERDATA$(I%) = INPUT$(256, #FF%)
NEXT I%
CLOSE #FF%

'Check the interrupt handlers for int 80h-E1h to see if they contain
'program code from either SBSIM or SBMIDI.
SBMIDI% = 0
SBSIM% = 0
FOR I% = &H80 TO &HE1
    'Get the address of the interrupt handler.
    MInternalGetIntVector I%, Segment%, Offset%
    'If the address is null, then the interrupt is not in use, and can be
    'skipped.
    IF Segment% = 0 AND Offset% = 0 THEN GOTO Skip:
    'The following code checks for the drivers by looking for the text
    '"SBMIDI" and "SBSIM" at certain locations in the driver code.  It
    'sounds simplistic, but it's very accurate.  If it doesn't work,
    'a different method is used.
    IF SBMIDI% = 0 THEN
        NewSegment% = CVI(MKI$(CVL(MKI$(Segment%) + CHR$(0) + CHR$(0)) - &H11&))
        DEF SEG = NewSegment%
        TEMP$ = ""
        FOR J% = 1 TO 6
            TEMP$ = TEMP$ + CHR$(PEEK(271 + J%))
        NEXT
        IF TEMP$ = "SBMIDI" THEN SBMIDI% = I%
    END IF
    IF SBSIM% = 0 THEN
        NewSegment% = CVI(MKI$(CVL(MKI$(Segment%) + CHR$(0) + CHR$(0)) - &H1&))
        DEF SEG = NewSegment%
        TEMP$ = ""
        FOR J% = 1 TO 5
            TEMP$ = TEMP$ + CHR$(PEEK(274 + J%))
        NEXT
        IF TEMP$ = "SBSIM" THEN SBSIM% = I%
    END IF
 
    'This is the second detection method.  It's more complex than the first
    'method, but not really any more accurate.  In fact, it's probably
    'less accurate.  It's kind of a last ditch effort in case the first
    'method fails.

    'Point to the segment of the interrupt handler.
    DEF SEG = Segment%
    'Read 256 bytes of the driver code.
    DRIVERDATA$(5) = ""
    FOR J% = 0 TO 255
        Byte% = PEEK(Offset% + J%)
        DRIVERDATA$(5) = DRIVERDATA$(5) + CHR$(Byte%)
    NEXT J%
    'Check to see if the code matches any of the previously saved data.
    FOR J% = 1 TO 4
        MATCH% = 1
        FOR k% = 0 TO 255
            IF MID$(DRIVERDATA$(J%), k% + 1, 1) <> MID$(DRIVERDATA$(5), k% + 1, 1) THEN
                SELECT CASE k%
                    CASE IS = 14, 15, 113, 114, 235, 236
                    CASE ELSE
                        MATCH% = 0
                        EXIT FOR
                END SELECT
            END IF
        NEXT k%
        IF MATCH% THEN
            IF J% = 1 THEN SBSIM% = I%
            IF J% <> 1 THEN SBMIDI% = I%
        END IF
        IF SBSIM% <> 0 AND SBMIDI% <> 0 THEN EXIT FOR
    NEXT J%
    IF SBSIM% <> 0 AND SBMIDI% <> 0 THEN EXIT FOR
Skip:
NEXT I%
MIDI.ERROR = 0
END SUB

'MIDIError - Translates a QMIDI error code into text
FUNCTION MIDIError$
SELECT CASE MIDI.ERROR
        CASE 0: MIDIError$ = "NO ERROR"
        CASE 1: MIDIError$ = "FILE CONTAINS NO DATA"
        CASE 2: MIDIError$ = "FILE IS TOO LARGE"
        CASE 3: MIDIError$ = "NO MIDI FILE PLAYING"
        CASE 4: MIDIError$ = "INVALID SBMIDI INTERRUPT"
        CASE 5: MIDIError$ = "INVALID SBSIM INTERRUPT"
        CASE 6: MIDIError$ = "NO MIXER CHIP"
        CASE 7: MIDIError$ = "COULD NOT DETECT SOUND CARD"
        CASE 8: MIDIError$ = "FEATURE UNAVAILABLE"
        CASE 9: MIDIError$ = "FILE IS CORRUPT"
        CASE 10: MIDIError$ = "INVALID SOUND CARD TYPE"
        CASE ELSE: MIDIError$ = "UNKNOWN ERROR"
END SELECT
END FUNCTION

SUB MInternalGetIntVector (IntNum%, Segment%, Offset%) STATIC
'If the code hasn't been loaded already, do it now.
IF GetIntVCodeLoaded% = 0 THEN
    asm$ = asm$ + CHR$(&H55)
    asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)
    asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA)
    asm$ = asm$ + CHR$(&H8A) + CHR$(&H7)
    asm$ = asm$ + CHR$(&HB4) + CHR$(&H35)
    asm$ = asm$ + CHR$(&HCD) + CHR$(&H21)
    asm$ = asm$ + CHR$(&H8C) + CHR$(&HC1)
    asm$ = asm$ + CHR$(&H89) + CHR$(&HDA)
    asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)
    asm$ = asm$ + CHR$(&H89) + CHR$(&HF)
    asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)
    asm$ = asm$ + CHR$(&H89) + CHR$(&H17)
    asm$ = asm$ + CHR$(&H5D)
    asm$ = asm$ + CHR$(&HCB)
    asm$ = asm$ + CHR$(&H34) + CHR$(&H0)
    asm$ = asm$ + CHR$(&H60)
    asm$ = asm$ + CHR$(&H23) + CHR$(&H0)
    GetIntVCodeLoaded% = 1
END IF
'Execute the code
DEF SEG = VARSEG(asm$)
CALL ABSOLUTE(IntNum%, Segment%, Offset%, SADD(asm$))
END SUB

SUB MIntX (IntNum AS INTEGER, Regs AS Registers) STATIC
'$DYNAMIC

STATIC filenum AS INTEGER, IntOffset AS INTEGER, Loaded AS INTEGER
                 
        ' use fixed-length string to fix its position in memory
        ' and so we don't mess up string pool before routine
        ' gets its pointers from caller

DIM IntCode AS STRING * 200
IF NOT Loaded THEN                     ' loaded will be 0 first time
        RESTORE IntXCodeData:
 
        FOR k% = 1 TO 145
                READ h%
                MID$(IntCode, k%, 1) = CHR$(h%)
        NEXT

        '  determine address of interrupt no. offset in IntCode

        IntOffset% = INSTR(IntCode$, CHR$(&HCD) + CHR$(&H21)) + 1
        Loaded% = -1
END IF

SELECT CASE IntNum

        CASE &H25, &H26, IS > 255               ' ignore these interrupts

        CASE ELSE
                DEF SEG = VARSEG(IntCode)             ' poke interrupt number into
                POKE VARPTR(IntCode) * 1& + IntOffset - 1, IntNum     ' code block
                CALL ABSOLUTE(Regs, VARPTR(IntCode$))               ' call routine
END SELECT

END SUB

REM $STATIC
'LoadMIDI - loads a MIDI file into memory
SUB MLoadMidi (FileName$) STATIC
'See if an extension was supplied, and if not, add one.
IF INSTR(FileName$, ".") = 0 THEN FileName$ = FileName$ + ".MID"
'Open the file
FF% = FREEFILE
OPEN FileName$ FOR BINARY AS #FF%
FileLen& = LOF(FF%)
CLOSE #FF%
'If the file is empty, delete it and exit now.
IF FileLen& = 0 THEN KILL FileName$: MIDI.ERROR = 1: EXIT SUB
'Make the filename an ASCIIZ string.
FileName$ = FileName$ + CHR$(0)

'Attempt to allocate a block of conventional memory.
QMIDIRegs.AX = &H4800
QMIDIRegs.BX = (FileLen& \ 16) + 1
CALL MIntX(&H21, QMIDIRegs)
'If the block couldn't be allocated, it means there's not enough free
'memory.  To fix this, we need to ask BASIC to release some of the memory
'it's using:
IF QMIDIRegs.AX = 7 OR QMIDIRegs.AX = 8 THEN
        'Find out how much memory is available, in kilobytes.
        LargestBlock& = QMIDIRegs.BX
        LargestBlock& = LargestBlock& * 16
        'Calculate the amount of memory that BASIC needs to release for us.
        MEM.ALLOCATED = (FileLen& + 2048) - LargestBlock&
        'Attempt to release the memory.
        A& = SETMEM(-MEM.ALLOCATED)
        'Try again to allocate a block of memory
        QMIDIRegs.AX = &H4800
        QMIDIRegs.BX = (FileLen& \ 16) + 1
        CALL MIntX(&H21, QMIDIRegs)
        'If the second attempt was unsuccessful, then there just isn't
        'enough memory, and an error needs to be returned.
        IF QMIDIRegs.AX = 7 OR QMIDIRegs.AX = 8 THEN
                'Give any memory we took back to BASIC.
                A& = SETMEM(MEM.ALLOCATED)
                'Return an error.
                MIDI.ERROR = 2
                MEM.SEGMENT = 0
                'Abort.
                EXIT SUB
        END IF
END IF
'If the memory was allocated successfully, store the segment
'of the memory block.
MEM.SEGMENT = QMIDIRegs.AX
MIDISegment& = QMIDIRegs.AX

'Open the MIDI file using a DOS interrupt.
QMIDIRegs.AX = &H3D00
QMIDIRegs.dx = SADD(FileName$)
QMIDIRegs.DS = VARSEG(FileName$)
CALL MIntX(&H21, QMIDIRegs)
'Store the file handle.
Handle% = QMIDIRegs.AX
'Read the data from the file in 16 kilobyte increments.
FOR I& = 1 TO FileLen& STEP 16384
        QMIDIRegs.AX = &H3F00
        QMIDIRegs.CX = 16384
        QMIDIRegs.dx = 0
        QMIDIRegs.DS = VAL("&H" + HEX$(MIDISegment&))
        QMIDIRegs.BX = Handle%
        CALL MIntX(&H21, QMIDIRegs)
        MIDISegment& = MIDISegment& + 1024
NEXT I&

'Close the file
QMIDIRegs.AX = &H3E00
QMIDIRegs.BX = Handle%
CALL MIntX(&H21, QMIDIRegs)

MIDI.ERROR = 0


END SUB

SUB MLoopMIDI
IF SBMIDI.INTERRUPT < &H80 AND SENSITIVE <> 0 THEN MIDI.ERROR = 4: EXIT SUB
QMIDIRegs.BX = 11
CALL MIntX(SBMIDI.INTERRUPT, QMIDIRegs)
IF QMIDIRegs.AX = 0 THEN MPlayMidi

END SUB

'PlayMIDI - Begins playing a MIDI file in the background.
SUB MPlayMidi STATIC
IF SBMIDI.INTERRUPT < &H80 AND SENSITIVE <> 0 THEN MIDI.ERROR = 4: EXIT SUB
'If sound is not disabled....
IF SOUND.DISABLED = 0 THEN
        'Call the SBMIDI driver to begin playing the MIDI file.
        QMIDIRegs.BX = 4
        QMIDIRegs.dx = MEM.SEGMENT
        QMIDIRegs.AX = 0
        CALL MIntX(SBMIDI.INTERRUPT, QMIDIRegs)
        QMIDIRegs.BX = 5
        CALL MIntX(SBMIDI.INTERRUPT, QMIDIRegs)
        'If the music could not be started, return an error.
        IF QMIDIRegs.AX <> 0 THEN MIDI.ERROR = 11: EXIT SUB
        'Start the MIDI timer.
        MIDI.PLAYTIME = TIMER
END IF
MIDI.ERROR = 0
END SUB

'StopMIDI - Stops playing MIDI file
SUB MStopMIDI STATIC
IF SBMIDI.INTERRUPT < &H80 AND SENSITIVE <> 0 THEN MIDI.ERROR = 4: EXIT SUB
'Call the SBMIDI driver to stop the music.
IF MIDI.PLAYTIME THEN
        QMIDIRegs.BX = 4
        QMIDIRegs.dx = MEM.SEGMENT
        QMIDIRegs.AX = 0
        CALL MIntX(SBMIDI.INTERRUPT, QMIDIRegs)
        MIDI.ERROR = 0
ELSE
        MIDI.ERROR = 3
END IF
'If a block of memory was allocated to hold the MIDI file....
IF MEM.SEGMENT THEN
        'Release the block of memory.
        QMIDIRegs.ES = MEM.SEGMENT
        QMIDIRegs.AX = &H4900
        CALL MIntX(&H21, QMIDIRegs)
        'Give back all the memory we took from BASIC.
        A& = SETMEM(MEM.ALLOCATED)
END IF
MEM.SEGMENT = 0
MIDI.PLAYTIME = 0
END SUB

FUNCTION MTimeMIDI!
'If a MIDI file is paused, lock the current playing time
IF PAUSED > 0! THEN
    MTimeMIDI! = PAUSED
    MIDI.ERROR = 0
'If a MIDI file is playing, carry out the timing routine
ELSEIF MIDI.PLAYTIME THEN
    'Get the current time
    CurrentTime! = TIMER
    'If midnight has come since the MIDI file started playing, change
    'CurrentTime! accordingly
    IF CurrentTime! - MIDI.PLAYTIME < 0 THEN
        CurrentTime! = 86400 + CurrentTime!
    END IF
    'Get the final result
    MTimeMIDI! = CurrentTime! - MIDI.PLAYTIME
    MIDI.ERROR = 0
ELSE
    MIDI.ERROR = 3
END IF
END FUNCTION

SUB StatAboutMenu

'StatOpenBox 10, 101, 6, 313, 193
DQBsetclipbox 106, 11, 308, 188
P = -175
F = 0
DO
DQBcopylayer 10, 1
L = 415
X$ = "Warrior of the ChiChi": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 13 - P, 31
X$ = "was created by Majiko": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 23 - P, 31
X$ = "---------------------": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 33 - P, 31
X$ = "Thanks to:": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 43 - P, 31
X$ = "Angello Motta": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 55 - P, 31
X$ = "Jesse Dorland": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 67 - P, 31
X$ = "Omni-Overmind": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 79 - P, 31
X$ = "Roy Sylvester": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 91 - P, 31
X$ = "Some encouragement from": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 105 - P, 31
X$ = "Roy Sylvester": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 118 - P, 31
X$ = "Omni-Overmind": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 129 - P, 31
X$ = "Eric Cashen": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 141 - P, 31
X$ = "--------------------": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 150 - P, 31
X$ = "E-Mail Majiko!": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 160 - P, 31
X$ = "majiko@geocities.com": DQBPrint 1, X$, (L - (LEN(X$) * 8)) / 2, 175 - P, 4
DQBcopylayer 1, VIDEO
P = P + 1
IF F = 0 THEN DQBwait 10: F = 1
IF DQBinkey$ <> "" THEN DQBclearlayer 1: DQBsetclipbox 0, 0, 319, 199: EXIT SUB
DQBwait 3
LOOP UNTIL P = 180
DQBclearlayer 1
DQBsetclipbox 0, 0, 319, 199
END SUB

FUNCTION StatCursorKey

StatCursorKey = -99
MLoopMIDI
IF DQBkey(KEYRIGHT) THEN
StatCursorKey = -97
EXIT FUNCTION
END IF
IF DQBkey(KEYLEFT) THEN
StatCursorKey = -98
EXIT FUNCTION
END IF


IF DQBkey(KEYDOWN) THEN
CursorPosition = CursorPosition + 1
StatCursorKey = -2
EXIT FUNCTION
END IF

IF DQBkey(KEYUP) THEN
CursorPosition = CursorPosition - 1
StatCursorKey = -2
EXIT FUNCTION
END IF

IF DQBkey(KEYENTER) OR DQBkey(KEYSPACE) THEN
StatCursorKey = CursorPosition
EXIT FUNCTION
END IF

IF DQBkey(KEYESC) THEN
StatCursorKey = -3
EXIT FUNCTION
END IF

END FUNCTION

SUB StatEndGame
MStopMIDI
DQBclose
END

END SUB

SUB StatOpenBox (Page, X, Y, X2, Y2)

DQBboxf Page, X, Y, X2, Y2, 67
DQBbox Page, X, Y, X2, Y2, 18
DQBbox Page, X + 1, Y + 1, X2 - 1, Y2 - 1, 19
DQBbox Page, X + 2, Y + 2, X2 - 2, Y2 - 2, 20
DQBbox Page, X + 3, Y + 3, X2 - 3, Y2 - 3, 19
DQBbox Page, X + 4, Y + 4, X2 - 4, Y2 - 4, 18

END SUB

SUB StatOpenMenu

DQBclearlayer 10
CursorPosition = 0
StatOpenBox 10, 0, 0, 319, 199
StatOpenBox 10, 101, 6, 313, 193
TextSetFont
DQBPrint 10, "Items", 26, 7, 31
DQBPrint 10, "Status", 26, 27, 31
DQBPrint 10, "Equip", 26, 47, 31
DQBPrint 10, "Magic", 26, 67, 31
DQBPrint 10, "Options", 26, 87, 31
DQBPrint 10, "About", 26, 107, 31
DQBPrint 10, "Quit", 26, 127, 31
DQBcopylayer 10, 1
DQBPut 1, 7, 7 + (20 * CursorPosition), VARSEG(Cursor%(1)), VARPTR(Cursor%(1))
DQBcopylayer 1, VIDEO
DQBwait 10
DO

DQBwait 6
A = StatCursorKey
IF A <> -99 THEN
IF A = 6 THEN StatEndGame
IF A = -3 THEN DQBwait 10: EXIT SUB
IF A = 4 THEN StatOptionsMenu
IF A = 5 THEN StatAboutMenu
IF CursorPosition > 6 THEN CursorPosition = 0
IF CursorPosition < 0 THEN CursorPosition = 6
DQBcopylayer 10, 1
DQBPut 1, 7, 7 + (20 * CursorPosition), VARSEG(Cursor%(1)), VARPTR(Cursor%(1))
DQBcopylayer 1, VIDEO
END IF

LOOP
END SUB

SUB StatOptionsMenu

'StatOpenBox 10, 101, 6, 313, 193
TextSetFont
CursorPosition = 0
DQBwait 10
Redoo:
DQBcopylayer 10, 1
A$ = "Options"
DQBPrint 1, A$, 108, 13, 31
DQBLine 1, 108, 22, 109 + LEN(A$) * 8, 22, 31
IF MidiToggle = YES THEN Col = 31 ELSE Col = 24
DQBPrint 1, "MIDI Soundtrack On", 126, 46, Col
IF MidiToggle = NO THEN Col = 31 ELSE Col = 24
DQBPrint 1, "MIDI Soundtrack Off", 126, 66, Col
IF TileSetNo = 1 THEN Col = 31 ELSE Col = 19
DQBPrint 1, "Save Game", 126, 86, Col
DQBPrint 1, "Load Game", 126, 106, 31
DQBPut 1, 108, 46 + (20 * CursorPosition), VARSEG(Cursor%(1)), VARPTR(Cursor%(1))
DQBcopylayer 1, VIDEO
DO

DQBwait 6
A = StatCursorKey
IF A <> -99 THEN
IF A = -3 OR A = -98 THEN DQBwait 10: EXIT SUB
IF A = 1 AND MidiToggle = YES THEN MidiToggle = NO: MStopMIDI
IF A = 0 AND MidiToggle = NO THEN MidiToggle = YES: MIDISET = NO: MStopMIDI: DoMidi OldMidi$
IF CursorPosition > 3 THEN CursorPosition = 0
IF CursorPosition < 0 THEN CursorPosition = 3
GOTO Redoo
END IF

LOOP



DQBcopylayer 1, VIDEO

END SUB

SUB TextClearBox

XPos = 319 / 2
YPos = 100
DQBclearlayer 3
SizeX = 150
SizeY = 42
DQBclearlayer 3
DQBcopylayer 1, 3
TextChop(1).X = XPos - SizeX: TextChop(1).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos - SizeY)
TextChop(2).X = XPos - SizeX: TextChop(2).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos + SizeY)
TextChop(3).X = XPos + SizeX: TextChop(3).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos - SizeY)
TextChop(4).X = XPos + SizeX: TextChop(4).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos + SizeY)

DQBboxf 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 67
DQBbox 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 20
DQBbox 3, XPos - SizeX + 1, YPos - SizeY + 1, XPos + SizeX - 1, YPos + SizeY - 1, 21
DQBbox 3, XPos - SizeX + 2, YPos - SizeY + 2, XPos + SizeX - 2, YPos + SizeY - 2, 22
DQBbox 3, XPos - SizeX + 3, YPos - SizeY + 3, XPos + SizeX - 3, YPos + SizeY - 3, 21
DQBbox 3, XPos - SizeX + 4, YPos - SizeY + 4, XPos + SizeX - 4, YPos + SizeY - 4, 20
FOR Z = 1 TO 4: DQBPset 3, TextChop(Z).X, TextChop(Z).Y, TextChop(Z).C: NEXT Z

DQBcopylayer 3, VIDEO


END SUB

SUB TextCloseBox
XPos = 319 / 2
YPos = 100
SizeX = 150
SizeY = 42
DQBclearlayer 3
DO
SizeX = SizeX - 3
SizeY = SizeY - 1
IF SizeX < 5 THEN SizeX = 5
IF SizeY < 5 THEN SizeY = 5
DQBclearlayer 3
DQBcopylayer 1, 3
TextChop(1).X = XPos - SizeX: TextChop(1).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos - SizeY)
TextChop(2).X = XPos - SizeX: TextChop(2).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos + SizeY)
TextChop(3).X = XPos + SizeX: TextChop(3).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos - SizeY)
TextChop(4).X = XPos + SizeX: TextChop(4).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos + SizeY)

DQBboxf 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 67
DQBbox 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 20
DQBbox 3, XPos - SizeX + 1, YPos - SizeY + 1, XPos + SizeX - 1, YPos + SizeY - 1, 21
DQBbox 3, XPos - SizeX + 2, YPos - SizeY + 2, XPos + SizeX - 2, YPos + SizeY - 2, 22
DQBbox 3, XPos - SizeX + 3, YPos - SizeY + 3, XPos + SizeX - 3, YPos + SizeY - 3, 21
DQBbox 3, XPos - SizeX + 4, YPos - SizeY + 4, XPos + SizeX - 4, YPos + SizeY - 4, 20
FOR Z = 1 TO 4: DQBPset 3, TextChop(Z).X, TextChop(Z).Y, TextChop(Z).C: NEXT Z

DQBcopylayer 3, VIDEO

LOOP UNTIL SizeX = 5 AND SizeY = 5

END SUB

SUB TextOpenBox

XPos = 319 / 2
YPos = 100
SizeX = 1
SizeY = 1
DQBclearlayer 3
DO
SizeX = SizeX + 3
SizeY = SizeY + 1
IF SizeX > 150 THEN SizeX = 150
IF SizeY > 42 THEN SizeY = 42
DQBclearlayer 3
DQBcopylayer 1, 3
TextChop(1).X = XPos - SizeX: TextChop(1).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos - SizeY)
TextChop(2).X = XPos - SizeX: TextChop(2).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos - SizeX, YPos + SizeY)
TextChop(3).X = XPos + SizeX: TextChop(3).Y = YPos - SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos - SizeY)
TextChop(4).X = XPos + SizeX: TextChop(4).Y = YPos + SizeY: TextChop(0).C = DQBpoint(3, XPos + SizeX, YPos + SizeY)

DQBboxf 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 67
DQBbox 3, XPos - SizeX, YPos - SizeY, XPos + SizeX, YPos + SizeY, 20
DQBbox 3, XPos - SizeX + 1, YPos - SizeY + 1, XPos + SizeX - 1, YPos + SizeY - 1, 21
DQBbox 3, XPos - SizeX + 2, YPos - SizeY + 2, XPos + SizeX - 2, YPos + SizeY - 2, 22
DQBbox 3, XPos - SizeX + 3, YPos - SizeY + 3, XPos + SizeX - 3, YPos + SizeY - 3, 21
DQBbox 3, XPos - SizeX + 4, YPos - SizeY + 4, XPos + SizeX - 4, YPos + SizeY - 4, 20
FOR Z = 1 TO 4: DQBPset 3, TextChop(Z).X, TextChop(Z).Y, TextChop(Z).C: NEXT Z

DQBcopylayer 3, VIDEO

LOOP UNTIL SizeX = 150 AND SizeY = 42

END SUB

SUB TextResetLines

FOR Z = 1 TO 9
TextString$(Z) = ""
NEXT Z

END SUB

SUB TextSetFont

IF FontLoaded = YES THEN
DQBSetFont Font
ELSE
DQBSetBIOSFont
END IF

END SUB

SUB TextShowText

DQBclearlayer 6
XPos = (319 / 2) - 150 + 8
YPos = 100 - 43
YPos = YPos + 8
FOR Z = 1 TO 9
A$ = LTRIM$(RTRIM$(TextString$(Z)))
IF A$ = "endtext" OR A$ = "xx" THEN DQBwaitkey KEYSPACE: TextCloseBox: EXIT SUB
IF A$ = "pause" OR A$ = "--" THEN DQBwaitkey KEYSPACE: GOTO Nextline
IF A$ = "clear" OR A$ = "cc" THEN DQBwaitkey KEYSPACE: TextClearBox: DQBclearlayer 6: YPos = 100 - 35: GOTO Nextline
FOR TextLength = 0 TO LEN(A$)
DQBPrint 6, LEFT$(A$, TextLength), XPos, YPos, 31
DQBcopytranslayer 6, 3
DQBcopylayer 3, VIDEO
DQBwait TextSpeed
NEXT TextLength
YPos = YPos + 8
Nextline:
NEXT Z
DQBwaitkey KEYSPACE
DQBclearlayer 6
END SUB

SUB XFXQuake (Times)

DQBcopylayer VIDEO, 10
FOR Z = 1 TO Times
DQBscroll VIDEO, 0, -1
DQBscroll VIDEO, 0, -1
DQBscroll VIDEO, 0, 1
DQBscroll VIDEO, 0, 1
NEXT Z
DQBcopylayer 10, VIDEO
END SUB

SUB ZDocLayers

'1   Copy All Screen Layers to Here then show
'2   Sprites
'3   TextBox
'4   Scenery
'5   Scrolling Water Filler
'6   Scrolling Text for Textbox  (Layer 3)
''''''''''''''''''''''''''
'Triggers
'
' 0   -   Gyuhn talks to Lord Zevan about entering Training Dungeon
' 1   -   TriggerStep in Training dungeon that reveals path to knight.
' 2   -   Signifies when boss at training dungeon is defeated

END SUB

